export type GeneralDoubleLinkedNode<T> = DoubleLinkedNode<T> | null;
export interface DoubleLinkedNode<T> {
    /**
     * 值域
     */
    val: T;
    /**
     * 后继节点
     */
    next?: GeneralDoubleLinkedNode<T>;
    /**
     * 前驱节点
     */
    prev?: GeneralDoubleLinkedNode<T>;
}
/**
 * 数组转双向链表
 * @param arr 数据源
 * @returns
 */
export declare function arrToDoubleLinkedList<T>(arr: T[]): {
    head: GeneralDoubleLinkedNode<T>;
    tail: GeneralDoubleLinkedNode<T>;
};
