/**
 * 数组转链表
 * @param initArr 原始数组
 * @returns
 */
export function arrToLinkedList(initArr) {
    if (!Array.isArray(initArr) || initArr.length === 0) {
        return null;
    }
    let head = null;
    let tail = null;
    initArr.forEach((item) => {
        let node = {
            val: item,
            next: null,
        };
        if (head === null) {
            head = node;
            tail = node;
        }
        else {
            tail.next = node;
            tail = node;
        }
    });
    return head;
}
